Attribute VB_Name = "PatternRecognitionTools"


Public Function DirectiveGrad(F() As Byte, XSize As Integer, YSize As Integer, xi As Integer, yi As Integer, dirGrads() As Single) As Integer
Dim dirNo As Integer, dirGap As Single
Dim a As Integer, b As Integer, i As Integer
Dim xx As Single, yy As Single, stp As Integer, wdth As Integer
Dim xxt As Single, yyt As Single
Dim pt As Single, wtsum As Single, wt As Single
Dim rFact As Single, rIndx As Integer, maxthk As Integer '**
Dim xp As Single, yp As Single

' dirNo is the number of directional lines along which the search is done
dirNo = 8  ' Can't be changed
eps = Round(10 * maxExtentFact)

xp = CSng(xi)
yp = CSng(yi)
pt = CSng(F(xi, yi))

i = -1
For a = -1 To 1
    For b = -1 To 1
        i = i + 1
        If a = 0 And b = 0 Then
            i = i - 1
            GoTo ths
        End If
        dirGrads(i) = 0
        wtsum = 0
        If a * b = 0 Then
            rFact = 1
            rIndx = 0 '**
        Else
            rFact = Root2
            rIndx = 1 '**
        End If
        For stp = 1 To eps '***
            'xx = xp + setSign(a, stp)
            'yy = yp + setSign(b, stp)
            xx = xp + a * stp / rFact '***
            yy = yp + b * stp / rFact '***
            maxthk = CInt(thk * stp)
            For wdth = -maxthk To maxthk
                xxt = xx + b * wdth / rFact '***
                yyt = yy - a * wdth / rFact '***
                'xxt = xx + setSign(a, wdth)
                'yyt = yy - setSign(b, wdth)
                If (xxt >= 0) And (yyt >= 0) And (xxt < XSize) And (yyt < YSize) Then
                    ' dirGrads(i) = dirGrads(i) + CSng(F(xx, yy)) * (CSng(F(xx, yy)) - pt) / r
                    ' wt = 1 / (r * CSng(Abs(wdth) + 1))
                    wt = dirWt(stp, Abs(wdth), 0) '***
                    dirGrads(i) = dirGrads(i) + CSng(F(Round(xxt), Round(yyt))) * wt '***
                    wtsum = wtsum + wt
                End If
            Next wdth
        Next stp
        If Not (dirGrads(i) = 0) Then
            dirGrads(i) = dirGrads(i) / wtsum
        End If
ths:
    Next b
Next a

DirectiveGrad = 1
End Function



Public Function patternRotSearch(dirGrads1() As Single, G2() As Single, xSize2 As Integer, ySize2 As Integer, xExpect1 As Integer, yExpect1 As Integer, SearchRad As Integer, x2 As Integer, y2 As Integer, rotIndex As Integer) As Single
' Searches for the pattern with DirectiveGradients dirGrads1 inside F2 (with DirectiveGradients G2) and returns best result in (x2, y2)
' It is different from 'patternSearch' in respect to the fact that it conciders rotation of the patterns
' While comparing points, it also checks for similarities by rotating the local pattern.
' It checks for (rotIndex*45) degrees of rotations

Dim a As Integer, b As Integer, d As Integer, dum As Integer
'Dim dirGrad1(8) As Single, dirGrad2(8) As Single
Dim lastdivr As Single, divr As Single, tmp1 As Single, tmp2 As Single
Dim c1 As Integer, c2 As Integer, c As Integer

lastdivr = 1E+30
'dum = DirectiveGrad(F1, xSize1, ySize1, x1, y1, dirGrad1)

' Character_Recog.Print "Start!!!"
For i = -SearchRad To SearchRad
    For j = -SearchRad To SearchRad
        a = i + xExpect1
        b = j + yExpect1
        If a < 0 Or b < 0 Or a > xSize2 - 1 Or b > ySize2 - 1 Or Sqr(i * i + j * j) > SearchRad Then
            GoTo nxtSrch1
        End If
        'dum = DirectiveGrad(F2, xSize2, ySize2, a, b, dirGrad2)
        divr = 0
        For c = 0 To 7
            c1 = rotIndices(c)
            c2 = rotIndices(shifts(c, rotIndex))
            'divr = divr + (dirGrad1(c1) - dirGrad2(c2)) * (dirGrad1(c1) - dirGrad2(c2))
            tmp1 = dirGrads1(c1) - G2(a, b, c2)
            'If Not (G2(a, b, c2) = 0) Then
                'tmp2 = dirGrads1(c1) / G2(a, b, c2)
            'Else
                'tmp2 = 10000000000#
            'End If
            divr = divr + tmp1 * tmp1
            'divr = divr + Abs(tmp1)
        Next c
        'Character_Recog.Pattern.PSet (a, b), RGB(0, 0, 255)
        If lastdivr > divr Then
            lastdivr = divr
            x2 = a
            y2 = b
            'patternRotSearch = Sqr(i * i + j * j)
        End If
nxtSrch1:
    Next j
Next i

' Character_Recog.Print "End!!!"

patternRotSearch = lastdivr / 100000
'patternRotSearch = lastdivr * (2 + (SearchRad - patternRotSearch) / SearchRad) / 30000
'patternRotSearch = lastdivr / 200 ' Dividing just by a scaling factor
End Function





Public Function Normalize(x1() As Single, y1() As Single, x2() As Single, y2() As Single, n As Integer) As Integer
' This function takes care of badly shaped ranges of x1, y1, x2 and y2
' Normalizes the range of x1, y1, x2 and y2
Dim xmin1 As Single, xmax1 As Single, ymin1 As Single, ymax1 As Single
Dim xmin2 As Single, xmax2 As Single, ymin2 As Single, ymax2 As Single
Dim a As Integer

xmin1 = 100000
ymin1 = 100000
xmax1 = 0
ymax1 = 0
xmin2 = 100000
ymin2 = 100000
xmax2 = 0
ymax2 = 0

For a = 0 To n - 1
    If x1(a) < xmin1 Then
        xmin1 = x1(a)
    End If
    If y1(a) < ymin1 Then
        ymin1 = y1(a)
    End If
    If x1(a) > xmax1 Then
        xmax1 = x1(a)
    End If
    If y1(a) > ymax1 Then
        ymax1 = y1(a)
    End If

    If x2(a) < xmin2 Then
        xmin2 = x2(a)
    End If
    If y2(a) < ymin2 Then
        ymin2 = y2(a)
    End If
    If x2(a) > xmax2 Then
        xmax2 = x2(a)
    End If
    If y2(a) > ymax2 Then
        ymax2 = y2(a)
    End If
Next a
xrange1 = xmax1 - xmin1
yrange1 = ymax1 - ymin1
xrange2 = xmax2 - xmin2
yrange2 = ymax2 - ymin2

For a = 0 To n - 1
    x1(a) = (x1(a) - xmin1) / xrange1
    y1(a) = (y1(a) - ymin1) / yrange1
    x2(a) = (x2(a) - xmin2) / xrange2
    y2(a) = (y2(a) - ymin2) / yrange2
Next a
End Function





Public Function CplxVertRatio(x1() As Single, y1() As Single, x2() As Single, y2() As Single, ratio() As cplxpt, n As Integer) As cplxpt
' (x1(k), y1(k)) and (x2(k), y2(k)), i = 0 to n-1, are the corrosponding points in two images.
' Computes [(x1(k), y1(k)) - (x1(l), y1(l))] / [(x2(k), y2(k)) - (x2(l), y2(l))], for k,l = 0 to n-1, k < l, and stores the nC2 results in ratio
' The points (x, y) represent a point on a complex plane.
' Returns the average of all ratios
' Note: (x1, y1) are points on the standard image, while (x2, y2) are the corrosponding points on the test image -- the reason is the points in (x2, y2) may be very close, which should be rejected

Dim k As Integer, l As Integer, ratindex As Integer, nC2 As Integer
Dim cplxtmp1 As cplxpt, cplxtmp2 As cplxpt, cplxratio1 As cplxpt, cplxratio2 As cplxpt
Dim dx1 As Single, dx2 As Single, dy1 As Single, dy2 As Single

nC2 = n * (n - 1) / 2
CplxVertRatio.r = 0
CplxVertRatio.th = 0
For k = 0 To n - 2
    For l = k + 1 To n - 1
        'cplxtmp1 = getCplx(x1(k) - x1(l), y1(k) - y1(l))
        'cplxtmp2 = getCplx(x2(k) - x2(l), y2(k) - y2(l))
        'cplxratio1 = cplxDiv(cplxtmp1, cplxtmp2)
        'cplxratio2 = cplxDiv(cplxtmp2, cplxtmp1)
        
        'CplxVertRatio.r = CplxVertRatio.r + cplxratio.r
        'CplxVertRatio.th = CplxVertRatio.th + cplxratio.th
        'ratindex = getRindex(k, l, n)
        'ratio(ratindex) = (cplxratio1 + cplxratio2) / 2
        dx1 = x1(k) - x1(l)
        dx2 = x2(k) - x2(l)
        dy1 = y1(k) - y1(l)
        dy2 = y2(k) - y2(l)
        'cplxtmp1 = getCplx((dx1 * dx1 - dy1 * dy1 + dx2 * dx2 - dy2 * dy2) / 2, dx1 * dy1 + dx2 * dy2)
        'cplxtmp2 = getCplx(dx1 * dx2 - dy1 * dy2, dx1 * dy2 + dx2 * dy1)
        cplxtmp1 = getCplx(dx1, dy1)
        cplxtmp2 = getCplx(dx2, dy2)
        cplxratio1 = cplxDiv(cplxtmp2, cplxtmp1)
        
        CplxVertRatio.r = CplxVertRatio.r + cplxratio1.r
        CplxVertRatio.th = CplxVertRatio.th + cplxratio1.th
        ratindex = getRindex(k, l, n)
        ratio(ratindex) = cplxratio1
    Next l
Next k

CplxVertRatio.r = CplxVertRatio.r / nC2
CplxVertRatio.th = CplxVertRatio.th / nC2
End Function





Public Function SelectVert1(ratio() As cplxpt, ratAv As cplxpt, vertErr() As Single, n As Integer, vertIndex() As Integer, vertNo As Integer) As cplxpt
' Using the ratio obtained from CplxVertRatio, this function decides which vertices are acceptable
' Returns the indices of accepted vertices in vertIndex(j), j = 1 to vertNo
' And returns an average error in the acepted ratios
' vertErr stores the error in individual vertices

Dim nC2 As Integer
Dim rErr() As Single, thErr() As Single
Dim rAv As Single, thAv As Single
Dim rMin As Single, thMin As Single, rMax As Single, thMax As Single
Dim rRange As Single, thRange As Single
Dim a As Integer, b As Integer
Dim k As Integer, l As Integer, rIndx As Integer, dum As Integer
Dim selVert() As Integer, vertNoC2 As Integer, accptProp As Single
Dim localErr As Single

nC2 = n * (n - 1) / 2
ReDim selVert(n) As Integer
ReDim rErr(nC2) As Single, thErr(nC2) As Single

'rAv = thAv = 0
rAv = ratAv.r
thAv = ratAv.th

rMin = 1000000
thMin = 1000000
rMax = -1000000
thMax = -1000000

For a = 0 To nC2 - 1
    'rAv = rAv + ratio(a).r
    'thAv = thAv + ratio(a).th
    
    If ratio(a).r > rMax Then
        rMax = ratio(a).r
    End If
    If ratio(a).r < rMin Then
        rMin = ratio(a).r
    End If
    If ratio(a).th > thMax Then
        thMax = ratio(a).th
    End If
    If ratio(a).th < thMin Then
        thMin = ratio(a).th
    End If

'    sortRind(a) = a
'    sortTHind(a) = a
Next a
'rAv = rAv / nC2
'thAv = thAv / nC2
rRange = rMax - rMin
thRange = thMax - thMin

For a = 0 To nC2 - 1
    If Not (rRange = 0) Then
        rErr(a) = Abs(ratio(a).r - rAv) / rRange
    Else
        rErr(a) = 0
    End If
    If Not (thRange = 0) Then
        thErr(a) = Abs(ratio(a).th - thAv) / thRange
    Else
        thErr(a) = 0
    End If
Next a

' xxx
'For a = 0 To nC2 - 2
'    For b = a To nC2 - 1
'        If rErr(sortRind(a)) < rErr(sortRind(b)) Then
'            tmp = sortRind(a)
'            sortRind(a) = sortRind(b)
'            sortRind(b) = tmp
'        End If
'        If thErr(sortTHind(a)) < thErr(sortTHind(b)) Then
'            tmp = sortTHind(a)
'            sortTHind(a) = sortTHind(b)
'            sortTHind(b) = tmp
'        End If
'    Next b
'Next a
' xxx

For a = 0 To n - 1
    selVert(a) = 0
Next a

count = 0
rAv = 0
thAv = 0
rMin = 1000000
thMin = 1000000
rMax = -1000000
thMax = -1000000
For a = 0 To nC2 - 1
    If rErr(a) < rTol And thErr(a) < thTol Then
        dum = splitRindex(a, k, l, n)
        selVert(k) = selVert(k) + 1
        selVert(l) = selVert(l) + 1
        count = count + 1
        
        ' Now we calculate the average & range for the selected vertices
        rAv = rAv + ratio(a).r
        thAv = thAv + ratio(a).th
    
        If ratio(a).r > rMax Then
            rMax = ratio(a).r
        End If
        If ratio(a).r < rMin Then
            rMin = ratio(a).r
        End If
        If ratio(a).th > thMax Then
            thMax = ratio(a).th
        End If
        If ratio(a).th < thMin Then
            thMin = ratio(a).th
        End If
    End If
Next a
'Character_Recog.Print count

If Not (count = 0) Then
    rAv = rAv / count
    thAv = thAv / count
Else
    rAv = 1000000
    thAv = 1000000
End If
rRange = rMax - rMin
thRange = thMax - thMin

accptProp = accptPropFactor * (count / nC2)
vertNo = 0
For a = 0 To n - 1
    'Character_Recog.Print vertErr(a)
    If selVert(a) / (n - 1) > accptProp And vertErr(a) < LocalErrTol Then '*#*
    'If vertErr(a) < LocalErrTol Then
        vertIndex(vertNo) = a
        vertNo = vertNo + 1
    End If
Next a
'Character_Recog.Print vertNo

SelectVert1.r = 0
SelectVert1.th = 0

If Not (rRange = 0) Or Not (thRange = 0) Then
For a = 0 To vertNo - 2
    For b = a To vertNo - 1
        If vertIndex(a) < vertIndex(b) Then
            k = vertIndex(a)
            l = vertIndex(b)
        Else
            l = vertIndex(a)
            k = vertIndex(b)
        End If
        rIndx = getRindex(k, l, n)

        If Not (rRange = 0) Then
            SelectVert1.r = SelectVert1.r + (Abs(ratio(rIndx).r - rAv) ^ LocGlobBalnce) * ((vertErr(k) * vertErr(l)) ^ (1 - LocGlobBalnce)) / rRange
        End If
        If Not (thRange = 0) Then
            SelectVert1.th = SelectVert1.th + (Abs(ratio(rIndx).th - thAv) ^ LocGlobBalnce) * ((vertErr(k) * vertErr(l)) ^ (1 - LocGlobBalnce)) / thRange
        End If
    Next b
Next a
End If

'localErr = 0
'For a = 0 To vertNo - 1
    'localErr = localErr + vertErr(vertIndex(a))
'Next a

vertNoC2 = vertNo * (vertNo - 1) / 2
If Not (vertNoC2 = 0) Then
    SelectVert1.r = SelectVert1.r / vertNoC2
    SelectVert1.th = SelectVert1.th / vertNoC2
Else
    SelectVert1.r = 1E+20
    SelectVert1.th = 1E+20
End If

' Note: SelectVert1 returns an estimate of error among the selected vertices
End Function






' The following functions use the relation
' Rindex = (n-1) + (n-2) + ... +(n-k) + l - k , 0 <= k < l <= n-1

Public Function getRindex(k As Integer, l As Integer, n As Integer) As Integer
getRindex = n * k - k * (k + 1) / 2 + l - k
End Function


Public Function splitRindex(Rindex As Integer, k As Integer, l As Integer, n As Integer) As Integer
Dim tmpIndex As Integer, tmp As Integer

tmpIndex = Rindex
For k = 0 To n - 1
    tmp = (n - (k + 1))
    If tmpIndex > tmp Then
        tmpIndex = tmpIndex - tmp
    Else
        Exit For
    End If
Next k

l = tmpIndex + k
End Function



Public Function patternDiffR(charIndex As Integer, sampleIndex As Integer, RotScale As cplxpt) As Single
' Returns the difference between the unknown pattern and
' the database pattern with charIndex, sampleIndex

Dim cplxErr As cplxpt, dum As Integer, ptCount As Integer
Dim nC2 As Integer, rats() As cplxpt
Dim selIndex(50) As Integer, selNo As Integer, a As Integer
Dim xss1(50) As Single, yss1(50) As Single, xss2(50) As Single, yss2(50) As Single, erss2(50) As Single
Dim ind As Integer, erro As Single, tmperro As Single, i As Integer
Dim finalSelNo As Integer, finalRotIndex As Integer, finalSelIndex(50) As Integer
Dim ratAv As cplxpt, redPtG1(7) As Single
Dim xs1(50) As Integer, ys1(50) As Integer, xs2(50, 7) As Integer, ys2(50, 7) As Integer, sErrs(50, 7) As Single
Dim mindev As Single, lastdev As Single, xx As Integer, yy As Integer
Dim xxExpect As Integer, yyExpect As Integer
Dim xs1Expect(50) As Integer, ys1Expect(50) As Integer
Dim rSearch(50) As Single, ThtAng As Single
Dim PatternRotAng As Single
Dim rotAngIndx As Integer, ii As Integer
'Dim SearchSizeFact As Single

ptCount = vertNo(charIndex, sampleIndex)
nC2 = ptCount * (ptCount - 1) / 2
ReDim rats(nC2) As cplxpt
'Character_Recog.Print ptCount
erro = 1E+20
PatternRotAng = RedPrDir - prDirR(charIndex, sampleIndex)
'Character_Recog.Print "Ang1", PatternRotAng
'Character_Recog.Pattern.Circle (0, 0), 5
'Character_Recog.Pattern.Line (RedCGx, RedCGy)-(RedCGx + 30 * Cos(RedPrDir), RedCGy + 30 * Sin(RedPrDir)), RGB(255, 0, 0)
'Character_Recog.Pattern.Line (CGxR(charIndex, sampleIndex), CGyR(charIndex, sampleIndex))-(CGxR(charIndex, sampleIndex) + 30 * Cos(prDirR(charIndex, sampleIndex)), CGyR(charIndex, sampleIndex) + 30 * Sin(prDirR(charIndex, sampleIndex))), RGB(100, 0, 0)

While PatternRotAng > pi
    PatternRotAng = PatternRotAng - 2 * pi
Wend
While PatternRotAng < -pi
    PatternRotAng = PatternRotAng + 2 * pi
Wend
rotAngIndx = Round(-PatternRotAng / (pi / 4))

'Character_Recog.Print "Before patternRotSearch"
For a = 0 To ptCount - 1
xs1(a) = vertXs(charIndex, sampleIndex, a)
ys1(a) = vertYs(charIndex, sampleIndex, a)
'Picture1.PSet (X, Y), RGB(256, 0, 0)

'Character_Recog.Print "delta y", ys1(a) - CGyR(charIndex, sampleIndex), "delta x", xs1(a) - CGxR(charIndex, sampleIndex)

If Not (xs1(a) - CGxR(charIndex, sampleIndex) = 0) Then
    ThtAng = Atn(CSng(ys1(a) - CGyR(charIndex, sampleIndex)) / CSng(xs1(a) - CGxR(charIndex, sampleIndex)))
Else
    ThtAng = pi / 2
End If
If ys1(a) - CGyR(charIndex, sampleIndex) < 0 And xs1(a) - CGxR(charIndex, sampleIndex) <= 0 Then
    ThtAng = ThtAng - pi
ElseIf ys1(a) - CGyR(charIndex, sampleIndex) >= 0 And xs1(a) - CGxR(charIndex, sampleIndex) < 0 Then
    ThtAng = ThtAng + pi
End If
rSearch(a) = Sqr(CSng(xs1(a) - CGxR(charIndex, sampleIndex)) ^ 2 + CSng(ys1(a) - CGyR(charIndex, sampleIndex)) ^ 2)
'Character_Recog.Print ThtAng, rSearch(a)
ThtAng = ThtAng + PatternRotAng
xs1Expect(a) = RedCGx + CInt(maxExtentFact * rSearch(a) * Cos(ThtAng))
ys1Expect(a) = RedCGy + CInt(maxExtentFact * rSearch(a) * Sin(ThtAng))
'xs1Expect(a, 2) = RedCGx - CInt(rSearch(a) * Cos(ThtAng))
'ys1Expect(a, 2) = RedCGy - CInt(rSearch(a) * Sin(ThtAng))
'Character_Recog.Print "Pattern: delta y", ys1Expect(a, 1) - RedCGy, "delta x", xs1Expect(a, 1) - RedCGx
For i = 0 To 7
    'i = iVals(ii)
    redPtG1(i) = dirGradR(charIndex, sampleIndex, a, i)
    'Character_Recog.Print redPtG1(i)
Next i
For ii = rotAngIndx - 2 To rotAngIndx + 2
    i = iVals(ii)
    'Character_Recog.Print xmax, ymax

    ' mindev = patternRotSearch_backup1(redPtG1, redG, xmax, ymax, xx, yy, i)
    'Character_Recog.Print xs1Expect(a, 1), ys1Expect(a, 1), rSearch(a)
    mindev = patternRotSearch(redPtG1, redG, xmax, ymax, xs1Expect(a), ys1Expect(a), CInt(maxExtentFact * rSearch(a) * SearchSizeFact + 5 * SearchSizeFact), xx, yy, invRotIndices(i))
    'Exit Function
    xs2(a, i) = xx
    ys2(a, i) = yy
    sErrs(a, i) = mindev '*#*
    'If xx = 0 And yy = 0 Then
        'Character_Recog.Print xx, yy, xs1(a), ys1(a), mindev
    'End If
Next ii
Next a
'Character_Recog.Print "After patternRotSearch"

For a = 0 To ptCount - 1
    xss1(a) = CSng(xs1(a))
    yss1(a) = CSng(ys1(a))
Next a

For ii = rotAngIndx - 2 To rotAngIndx + 2
    i = iVals(ii)
    For a = 0 To ptCount - 1
        xss2(a) = CSng(xs2(a, i))
        yss2(a) = CSng(ys2(a, i))
        erss2(a) = sErrs(a, i)  '*#*
    Next a

    If Character_Recog.Check1.value = 1 Then
        dum = Normalize(xss1, yss1, xss2, yss2, ptCount)
        'Character_Recog.Print "After Normalize"
    End If
    ratAv = CplxVertRatio(xss1, yss1, xss2, yss2, rats, ptCount)
    'Character_Recog.Print "After CplxVertRatio"
    cplxErr = SelectVert1(rats, ratAv, erss2, ptCount, selIndex, selNo)
    'Character_Recog.Print "After SelectVert1"

    ' Maximum of error among r and th
    If ((ratAv.th < rotIndexVal(i) + pi / 4 And ratAv.th > rotIndexVal(i) - pi / 4) Or (i = 4 And ratAv.th < -pi + pi / 4 And ratAv.th > -pi - pi / 4)) And (Tan(ratAv.th / 2) < Tan(PatternRotAng / 2 + pi / 8) And Tan(ratAv.th / 2) > Tan(PatternRotAng / 2 - pi / 8)) Then
        If (Not (selNo = 0)) And cplxErr.r < 10000000000# And cplxErr.th < 10000000000# Then
            'If cplxErr.r < cplxErr.th Then
                'tmperro = cplxErr.th / ((selNo / ptCount) ^ selptWtExponent)
                'Character_Recog.Print " th: " & tmperro
            'Else
                'tmperro = cplxErr.r / ((selNo / ptCount) ^ selptWtExponent)
                'Character_Recog.Print " r: " & tmperro
            'End If
            tmperro = cplxErr.r * cplxErr.th / ((selNo / ptCount) ^ selptWtExponent)

            If tmperro < erro Then
                erro = tmperro
                finalSelNo = selNo
                finalRotIndex = i
                RotScale = ratAv
                'rotAngle = rotIndexVal(finalRotIndex)
                For a = 0 To finalSelNo - 1
                    finalSelIndex(a) = selIndex(a)
                Next a
            End If
        End If
    End If
Next ii
'Character_Recog.Print finalRotIndex, finalSelNo / ptCount, erro

'Character_Recog.Print "Rotation index chosen : " & finalRotIndex
'Character_Recog.Print "finally selected no of vertices : " & finalSelNo & " / " & ptCount
If Not (finalSelNo = 0) Then
    patternDiffR = erro
Else
    patternDiffR = -1
End If

End Function



Public Function GetMeans(F() As Byte, XSize As Integer, YSize As Integer, xCg As Integer, yCg As Integer, prDir As Single) As Integer
' Returns the CG and Principal direction (angle mage with +ve X-axis in radians) of the complement of F

Dim xi As Integer, yi As Integer, x1 As Integer, y1 As Integer
Dim m As Long, MX As Long, MXX As Long, MY As Long, MYY As Long, MXY As Long
Dim mi As Long, Mpr1 As Single, Mpr2 As Single, mSlop As Single, mDist As Single, mResDist As Single, DistMajor As Single, DistMinor As Single
'Dim Mmajor1 As Single, Mmajor2 As Single, Mminor1 As Single, Mminor2 As Single

m = 0
MX = 0
MXX = 0
MY = 0
MYY = 0
MXY = 0

For xi = 0 To XSize - 1
    For yi = 0 To YSize - 1
        mi = CLng(255 - F(xi, yi))
        m = m + mi
        MX = MX + yi * mi
        MY = MY + xi * mi
    Next yi
Next xi

xCg = CInt(CSng(MY) / CSng(m))
yCg = CInt(CSng(MX) / CSng(m))

For xi = 0 To XSize - 1
    For yi = 0 To YSize - 1
        x1 = (xi - xCg)
        y1 = (yi - yCg)
        mi = CLng(255 - F(xi, yi))
        MXX = MXX + y1 * y1 * mi
        MYY = MYY + x1 * x1 * mi
        MXY = MXY + x1 * y1 * mi
    Next yi
Next xi

If Not (MYY - MXX) = 0 Then
    prDir = 0.5 * Atn(2 * CDbl(MXY) / CDbl(MYY - MXX))
Else
    prDir = pi / 4
End If
If MXY < 0 And MYY - MXX <= 0 Then
    prDir = prDir - pi / 2
ElseIf MXY >= 0 And MYY - MXX < 0 Then
    prDir = prDir + pi / 2
End If


'Assigning direction to principal axis
mSlop = Tan(prDir)
mDist = 1 + mSlop * mSlop
Mpr1 = 0
Mpr2 = 0
For xi = 0 To XSize - 1
    For yi = 0 To YSize - 1
        x1 = (xi - xCg)
        y1 = (yi - yCg)
        mi = CLng(255 - F(xi, yi))
        DistMajor = y1 - mSlop * x1
        If x1 * Cos(prDir) + y1 * Sin(prDir) > 0 And x1 * Sin(prDir) - y1 * Cos(prDir) > 0 Then
            Mpr1 = Mpr1 + mi * DistMajor * DistMajor / mDist
        ElseIf x1 * Cos(prDir) + y1 * Sin(prDir) < 0 And x1 * Sin(prDir) - y1 * Cos(prDir) < 0 Then
            Mpr2 = Mpr2 + mi * DistMajor * DistMajor / mDist
        End If
    Next yi
Next xi

If Mpr2 < Mpr1 Then
    If prDir > 0 Then
        prDir = prDir - pi
    Else
        prDir = prDir + pi
    End If
End If

End Function

